// [ץ̾]
// makeCellInfo.cc

// [ɤץफ]
// makeCellInfo.cc ϡplain format V.1,2 ǡåȤ饻
// ³Фơ¼巯 dynamic wave ǥ
// ͿեץǤ

// [Ȥ]
// (1) ʤǵư :
//
// % makeCellInfo
// # Input file name (plain format V.1,2) : org_grid.dat
// # Output file name (cell info) : cellInfo.data
// 
// (2) Ĥǵư :
//
// % makeCellInfo org_grid.dat cellInfo.data
//
// org_grid.dat ΥեޥåȤϰʲΤ褦Ǥ
//
// @begin{org_grid.dat}
// 9 
// 1 1 newgrid-1-1.dat
// 1 2 newgrid-1-2.dat
// 1 3 newgrid-1-3.dat
// 2 1 newgrid-2-1.dat
// 2 2 newgrid-2-2.dat
// 2 3 newgrid-2-3.dat
// 3 1 newgrid-3-1.dat
// 3 2 newgrid-3-2.dat
// 3 3 newgrid-3-3.dat
// @end{org_grid.dat}
//
// cellInfo.dat ΥեޥåȤϰʲΤ褦Ǥ
//
// @begin{cellInfo.dat}
// 1 3    (åɥܥåֹ x, y)
// 7      (üο)
// 1 0    (üֹ, ־)
// 2 0
// 3 0
// 4 0
// 5 0
// 6 2
// 7 2
// 6      (ƻʬο)
// 1 2 1  (ƻʬֹ, ήüֹ, ήüֹ)
// 2 3 2
// 3 4 2
// 4 5 3
// 5 6 3
// 6 7 3
// 
// 2 1    (åɥܥåֹ x, y)
// ... ʲ֤ ...
// @end{cellInfo.dat}
//
// [ѥ]
// % make -f makeCellInfo.mak

#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "dfopen.h"
#include "khboolean.h"

int main(int argc, char** argv)
{
	// οΥå
	assert(argc == 1 || argc == 3);

	// plain format V.1,2 Υǡե̾
	char in[256], out[256];
	if (argc == 1) {
		printf("# Input file name (plain format V.1,2) : ");
		scanf("%s", in);
		printf("# Output file name (cell info) : ");
		scanf("%s", out);
	}
	else {
		sscanf(argv[1], "%s", in);
		sscanf(argv[2], "%s", out);
	}

	char buf[256];
	int numFile;				// plain format եο
	int ix, iy;					// åɥܥåֹ
	char fname[256];			// plain format ե̾
	int numEndPoint;			// üο
	int numSegment;				// ƻʬο
	int pnum;					// üֹ
	double x, y, z, w;			// ֺɸƻ
	int pos;					// ־
	int snum;					// ƻʬֹ

	int ue, le;					// ue : ήüֹ
								// le : ήüֹ

	FILE *fin, *fout;
	assert((fin = dataFileOpen(in)) != NULL);
	assert((fout = fopen(out, "w")) != NULL);

	assert(fgets(buf, 256, fin) != NULL);
	assert(sscanf(buf, "%d", &numFile) == 1);

	int i, j;
	for (i = 0; i < numFile; i++) {

		// plain format ե̾ɤ߹
		assert(fgets(buf, 256, fin) != NULL);
		assert(sscanf(buf, "%d %d %s", &ix, &iy, fname) == 3);

		FILE* fp;
		assert((fp = dataFileOpen(fname)) != NULL);

		KhBoolean inside = NO; // YES : ƻʬ
							   // NO  : ƻʬФ

		int gx, gy;
		while (fgets(buf, 256, fp) != NULL) {

			// [Map Number]
			if (strcmp(buf, "[Map Number]\n") == 0) {
				assert(fgets(buf, 256, fp) != NULL);
				assert(sscanf(buf, "%d %d", &gx, &gy) == 2);
				assert(ix == gx && iy == gy);
				fprintf(fout, "%d %d\n", ix, iy);
			}

			// [Number of End Points]
			if (strcmp(buf, "[Number of End Points]\n") == 0) {
				assert(fgets(buf, 256, fp) != NULL);
				assert(sscanf(buf, "%d", &numEndPoint) == 1);
				fprintf(fout, "%d\n", numEndPoint);
			}

			// [Data of End Points]
			if (strcmp(buf, "[Data of End Points]\n") == 0) {
				for (j = 0; j < numEndPoint; j++) {
					assert(fgets(buf, 256, fp) != NULL);
					assert(sscanf(buf, "%d %lf %lf %lf %d", 
								  &pnum, &x, &y, &z, &pos) == 5);
					if (pos == 0) {
						fprintf(fout, "%d %d\n", pnum, 2);
					}
					else {
						fprintf(fout, "%d %d\n", pnum, 1);
					}
				}
			}

			// [Number of River Segments]
			if (strcmp(buf, "[Number of River Segments]\n") == 0) {
				assert(fgets(buf, 256, fp) != NULL);
				assert(sscanf(buf, "%d", &numSegment) == 1);
				fprintf(fout, "%d\n", numSegment);
			}

			// [Data]
			if (strcmp(buf, "[Data]\n") == 0) {
				while (fgets(buf, 256, fp) != NULL) {
					assert(sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf",
								  &ix, &iy, &pnum, &snum, &pos, &x, &y,
								  &z, &w) == 9);
					// ʲƻʬä
					if (inside == NO && pos >= 0) {
						inside = YES;
						if (pnum < 0) le = -pnum;
						else if (pnum > 0) ue = pnum;
					}
					// Ĥβƻʬä
					else if (inside == YES && pos >= 0) {
						inside = NO;
						if (pnum < 0) le = -pnum;
						else if (pnum > 0) ue = pnum;
						fprintf(fout, "%d %d %d\n", snum, ue, le);
					}
				}
			}
		}
//		fprintf(fout, "\n");
		fclose(fp);
	}
	fclose(fin);
	fclose(fout);

	return 0;
}
